<?php $title = "Beispiel für SQL-Injections mit non root-User"; ?> 
<!DOCTYPE html>
<html> 
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title><?php echo $title; ?></title> 
</head>
<STYLE TYPE="text/css">
	body th, td
	{
		font-family:Arial, sans-serif;
	}
</STYLE>
<body>
<?php

	echo '<p><b>'.$title.'</b><p>';

	/*
		Bespiele für SQL-Injections
		SELECT * FROM LADEN WHERE haendler='Meier' or 1=1 durch Eingabe von "Meier' OR '1'='1
		
		SELECT * FROM LADEN WHERE haendler='Meier' union select hauptstadt, flaeche, eu from laender
		durch Eingabe von "Meier' union select hauptstadt, flaeche, eu from laender"
		
		SELECT * FROM LADEN WHERE haendler='XX' 
		         union SELECT `N_COLS`,`TABLE_ID`,`NAME` FROM information_schema.`INNODB_SYS_TABLES`#
		durch Eingabe von "XX' union SELECT `N_COLS`,`TABLE_ID`,`NAME` FROM information_schema.`INNODB_SYS_TABLES`#"
	*/
	
	const _P_FormName = 'LF';
		
	const _Input_Field			= 'Input_Field';
	const _Task_Field			= 'TASK';         // Task, es wird Der Task Wert und eine Id durch : (_TS_) getrennt übergenen
	const _Task_Do_SQL			= 'do_SQL';  	
	const _Init_SQL				= "SELECT * FROM LADEN WHERE haendler=";  	
	const _Input_Field_Begin	= 'Niemand';

	require("functions.php");
	const showSQL = 1;

	// Verbindung zur Datenbank, sie liegt lokalauf dem Rechner, User ist root, Passwort ist nicht definiert, Name der Datenbank ist hier datenbank
	$conn = new mysqli( 'localhost', 'Simple','Simple', 'erstedatenbank' );

	if ($conn->connect_error) {
		printf("Verbindungsfehler: %s\n", $conn->connect_error);
		exit();
	}

	// Bei Umlauten ist der korrekte Zeichensatz dringend notwendig!
	$sql_r = $conn->query("SET NAMES 'utf8'");
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
		
	if (!sizeof($_POST))
	{
		/*
		  Initial fall. Da das Script noch nicht aufgerufen worden ist, ist noch kein Formular angelegt 
		  und deshalb gibt es auch noch kein Input.
		  Alle Inputdaten werden über die Methode POST empfangen und dort gibt es noch nichtd
		*/
		
		$debugg = 0;
		$display = 1;
		//echo '<br>nix empfangen!';	
		$sql_command = _Init_SQL.'\'Niemand\'';		
		$_Input_Field = _Input_Field_Begin;
	}
	else
	{

		/*
		  Da das Script ist schon gelaufen und das Formular war schon angelegt 
		  Die Steuerung passiert über das Foumularfeld 
		  _TASK <Befehl>:<Id>
		  
		  Es gibt ein paar Befehle, die über const definiert sind. Ginter Seperator : steht eine Zahl, die eventuell ausgewertet werden kann.
		  Es könnte auch ein hidden-Formularfeld per Javascript gesetzt werden oder Dazen über Sessions verwaltet werden.
		*/

		$sql_command = _Init_SQL.'\''.$_POST[_Input_Field].'\'';		
		$_Input_Field = $_POST[_Input_Field];
		
	}

	echo '<form action="'.basename(__file__).'" name="'._P_FormName.'" method="POST">';
	echo '<p>'._Init_SQL.'<input type="text" name="'._Input_Field.'" value="'.$_Input_Field.'" size="100">'; // wird wahrscheinlich überschrieben, muss aber angelegt sein
	echo '<p><button type="submit" name="'._Task_Field.'" value="'._Task_Do_SQL.'">Abschicken des SQL-Kommandos</button><p>';


	
	// die eigentliche Queries
	echo '<p>Das auszuführende SQL-Kommando: <b>'.$sql_command.'</b><p>';
	
	$sql  = $sql_command;
		 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br><b>' . ws2html($sql) . '</b><p>';
	
	// Das Ergebnis der Query wird in Tabellenform ausgegeben	
	printTable($sql_r,$tab,$tabClose);
	
	// Die Verbindung zur Datenbank wird beendet	
	$conn->close();


?>

</form>

 </body>
</html>